#ifndef __CMRSREP
#define __CMRSREP

#include <vector>
#include <string>
using namespace std;

typedef struct v_index {
    int D0;
    int D1;
    int CUSTOMER;
    int STEINER;
} v_index;


class CMRSRep {
    
    private:
        string _filename;
        int _n_customers, _n_steiners;
        int _n_rings, _ring_capacity;
        int _V, _V1, _V2;
        v_index _index_x, _index_y, _index_z, _index_f, _index_p, _index_connection_cost, _index_routing_cost;
        vector<vector<double> > _connection_cost, _routing_cost;
        vector<string> _customers_labels, _steiners_labels;
        string _depot0_label, _depot1_label;
        
    public:
        CMRSRep(const string& filename);
        //CMRSRep(int n_customers, int n_steiners, int n_rings, int ring_capacity, vector<vector<double> > connection_cost, vector<vector<double> > routing_cost);
        string filename();
        int n_customers();
        int n_steiners();
        int n_rings();
        int ring_capacity();
        int V();
        int V1();
        int V2();
        int var_x(int i, int j);
        int var_y(int i, int j);
        int var_z(int i);
        int var_f(int i);
        int var_p(int i);
        int var_s();
        int var_t();
        int var_s1();
        int var_t1();
        v_index index_x();
        v_index index_y();
        v_index index_z();
        v_index index_f();
        v_index index_p();        
        v_index index_connection_cost();
        v_index index_routing_cost();
        vector<string> customers_labels();
        vector<string> steiners_labels();
        string depot0_label();
        string depot1_label();
        string label_x(int index, int i);
        string label_y(int index, int i);
        vector<vector<double> > connection_cost();
        vector<vector<double> > routing_cost();
        
};

#endif
