#!/usr/bin/python
# -*- coding: utf-8 -*-

# Gap
def obtener_gap(instancia):
    f = open(instancia+'.cplex.optb.log', 'r')
    lines = f.readlines()
    f.close()
    lines.reverse()
    gap = None
    for line in lines:
        if line.find('%') != -1:
            gap = round(float(line[line.find('%') - 6:line.find('%')]), 2)
            break            
    
    return gap


# Tiempos de ejecucion
f = open('tests-01-hb-cplex_default.log', 'r')
lines = f.readlines()
f.close()
tiempo = {}
for line in lines[1:]:
    instancia = line[19:line.find('2009')-1]
    tiempo[instancia] = float(line.split(' ')[2])


# Valores optimos
f = open('nohup.out', 'r')
lines = f.readlines()
f.close()

instancia = None
status = None
obj = None
gap = None
resultados = []
param = 1
for line in lines:
    if line.find('Construyendo instancia del problema') == 0:
        instancia = line[55:-1]
        n = int(instancia[17:20])
        u = int(instancia[25:28])
        m = int(instancia[22:23])
        w = int(instancia[30:33])
        q = int(instancia[35:37])        
    elif line.find('Objetivo (min)') == 0:
        if line[line.find('status')+9:line.find(')\n')] == '101':
            status = '1'
            gap = 0.0
        else:          
            gap = obtener_gap(instancia)        
            status = '0'
        
        obj = int(line[line.find('=')+2:line.find('status') - 2])
    
    if instancia != None and status != None:      
        if instancia in tiempo:
            resultados = resultados + [(instancia, n, m, q, u, w, param, obj, tiempo[instancia], gap)]
        else:
            resultados = resultados + [(instancia, n, m, q, u, w, param, obj, -1, gap)]
        
        instancia = None
        status = None
        obj = None
        gap = None

f = open('resultados.sql', 'w')
insert_stmt = 'insert into pruebas (instancia, n, m, q, u, w, param, obj, tiempo, gap) values (\'%s\', %d, %d, %d, %d, %d, %d, %f, %f, %f);\n'
lines = [insert_stmt % (r[0], r[1], r[2], r[3], r[4], r[5], r[6], r[7], r[8], r[9]) for r in resultados]
f.writelines(lines)
f.close()

