#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Ejemplo:
# ver_branching.py eil26.tsp.3.12.5.A.BDS.cmrsp.dat.cplex.optb.log
#
# Ejemplo para generar la imagen a partir de la especificacion del árbol:
# dot -Tpng -o eil26.tsp.3.12.5.A.BDS.cmrsp.dat.cplex.optb.log.png eil26.tsp.3.12.5.A.BDS.cmrsp.dat.cplex.optb.log.dot

import sys

if len(sys.argv) != 2:
    print 'Uso: ver_branching.py archivo_cplex.log'
    print 'Observación: el archivo de log de CPLEX debe tener información de logging para todos los nodos (debe ser CPX_PARAM_MIPINTERVAL = 1)'
    sys.exit(1)

filename_log = sys.argv[1]
filename_dot = filename_log+'.dot'
header_data = '   Node  Left     Objective  IInf  Best Integer     Best Node    ItCnt     Gap         Variable B Parent  Depth\n'


parent_rel = {0: None}
labels = {0: 'root'}

#################################################################################
# Obtiene la informacion del archivo de log de CPLEX
#################################################################################
f = open(filename_log,  'r')
lines = f.readlines()

for line in lines:
    id = 0
    if len(line) == 112 and line != header_data:
        node_id = int(line[1:7].lstrip().rstrip())
        var_label = line[80:95].lstrip().rstrip()
        parent_node_id = int(line[98:109].lstrip().rstrip())
        labels[node_id] = var_label
        parent_rel[node_id] = parent_node_id

f.close()

#################################################################################
# Escribe el archivo .dot con la estructura del arbol de branch-and-bound
#################################################################################
f = open(filename_dot,  'w')
f.write('digraph BranchAndBound {')
for rel in parent_rel.items():
    child = rel[0]
    parent = rel[1]
    if parent != None:
        f.write(str(parent)+' -> '+str(child)+'[label='+labels[child]+'];\n')

f.write('}')
f.close()

for (id,  label) in labels.items():
    print str(id) + ': ' + label


